package ij.plugin.frame.jedit;

import javax.swing.JPopupMenu;
import java.awt.Color;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2008</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class LNTextAreaDefaults {
    private static LNTextAreaDefaults DEFAULTS;

    public InputHandler inputHandler;
    public SyntaxDocument document;
    public boolean editable;

    public boolean caretVisible;
    public boolean caretBlinks;
    public boolean blockCaret;
    public int electricScroll;

    public int cols;
    public int rows;
    public SyntaxStyle[] styles;
    public Color caretColor;
    public Color selectionColor;
    public Color lineHighlightColor;
    public boolean lineHighlight;
    public Color bracketHighlightColor;
    public boolean bracketHighlight;
    public Color eolMarkerColor;
    public boolean eolMarkers;
    public boolean paintInvalid;

    public JPopupMenu popup;

    /**
     * Returns a new TextAreaDefaults object with the default values filled
     * in.
     */
    public static LNTextAreaDefaults getDefaults()
    {
            if(DEFAULTS == null)
            {
                    DEFAULTS = new LNTextAreaDefaults();

                    DEFAULTS.inputHandler = new DefaultInputHandler();
                    DEFAULTS.inputHandler.addDefaultKeyBindings();
                    DEFAULTS.document = new SyntaxDocument();
                    DEFAULTS.editable = false;

                    DEFAULTS.blockCaret = false;
                    DEFAULTS.caretVisible = false;
                    DEFAULTS.caretBlinks = false;
                    DEFAULTS.electricScroll = 3;

                    DEFAULTS.cols = 6;
                    DEFAULTS.rows = 25;
                    DEFAULTS.styles = SyntaxUtilities.getDefaultSyntaxStyles();
                    DEFAULTS.caretColor = Color.black; // Color.red;
                    DEFAULTS.selectionColor = new Color(0xccccff);
                    DEFAULTS.lineHighlightColor = new Color(0xe8f2fe);
                    //DEFAULTS.lineHighlightColor = new Color(0xe0e0e0);
                    DEFAULTS.lineHighlight = false;
                    DEFAULTS.bracketHighlightColor = Color.black;
                    DEFAULTS.bracketHighlight = false;
                    DEFAULTS.eolMarkerColor = new Color(0x009999);
                    DEFAULTS.eolMarkers = false; // true;
                    DEFAULTS.paintInvalid = false; //true;
            }

            return DEFAULTS;
    }

}
