package ij2x.plugin;

import ij.IJ;
import ij.ImageJ;
import ij.ImageStack;
import ij.plugin.PlugIn;

import ij2x.util.AWTImages;
import ij2x.util.BorderlessButton;
import ij2x.util.ImageIcons;
import ij2x.util.ResourceString;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class TransformPanel extends JPanel implements PlugIn, MouseListener, MouseMotionListener, ActionListener{
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray,Color.lightGray );
    private long mouseDownTime;
    public boolean startStop = true, flipflop=false;
    public static final int DOUBLE_CLICK_THRESHOLD = 50;
    private boolean pressed;
    public JPanel buttons;
    protected ImageJ ij;
    private JButton action;
    private ImageStack stack;
    public JPanel controlPanel=new JPanel();
    public JButton draggedButton, closeButton, undecoratedButton;
    public JButton tobeginnButton, revButton
                                  , stopButton, fwdButton, toendButton
                                   , rotLeftButton, rotRightButton, flipHorizontalButton
                                    , flipVerticalButton, rotButton, rotRoiButton, scaleButton
                                     , transButton, selectButton, nonselectButton;


                             private static ResourceBundle resources;
                             private int index = 0;

                             static {
                                 try {
                                     resources = ResourceBundle.getBundle("ij2x.plugin.resources.TransformBar",
                                                                          Locale.getDefault());
                                 } catch (MissingResourceException mre) {
                                     System.err.println("resources/TransformBar.properties not found");
                                     System.exit(1);
                                 }
                             }
    public TransformPanel(){
        ij = IJ.getInstance();
    }

    public void run(String arg){
        ij = IJ.getInstance();
        controlPanel=controlButton();
    }

    public JPanel controlButton() {
        buttons = new JPanel();
        buttons.setBorder(lightGrayBorder);
        FlowLayout buttonsFlowLayout = new FlowLayout(FlowLayout.LEFT, 0, 0);
        buttons.setLayout(buttonsFlowLayout);

        ImageIcon b1o = ImageIcons.getIcons(this);

        AWTImages.setImageDir("transDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "transbar"));

    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
      }

        rotLeftButton=BorderlessButton.createButton(this, rotLeftButton, "Rotate Left 90", icons[index++]);

        rotRightButton=BorderlessButton.createButton(this, rotRightButton, "Rotate Right 90", icons[index++]);

        rotRoiButton=BorderlessButton.createButton(this, rotRoiButton, "Rotate ROI", icons[index++]);

        rotButton=BorderlessButton.createButton(this, rotButton, "Rotate Arbitrarily", icons[index++]);

        scaleButton=BorderlessButton.createButton(this, scaleButton, "Scale", icons[index++]);

        flipHorizontalButton=BorderlessButton.createButton(this, flipHorizontalButton, "Flip Horizontal", icons[index++]);

        flipVerticalButton=BorderlessButton.createButton(this, flipVerticalButton, "Flip Vertical", icons[index++]);

        selectButton=BorderlessButton.createButton(this, selectButton, "Select Image", icons[index++]);

        nonselectButton=BorderlessButton.createButton(this, nonselectButton, "Non Select Image", icons[index++]);

        transButton=BorderlessButton.createButton(this, transButton, "Translate", icons[index++]);

        buttons.add(rotRightButton);
        buttons.add(rotLeftButton);
        buttons.add(rotRoiButton);
        buttons.add(flipHorizontalButton);
        buttons.add(flipVerticalButton);
        buttons.add(transButton);
        buttons.add(selectButton);
        buttons.add(nonselectButton);
        buttons.add(rotButton);
        buttons.add(scaleButton);
        return buttons;
    }


    void toBeginn() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "beginn");
    }
    void toEnd() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "end");
    }
    void previous() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "previous");
    }
    void next() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "next");
    }

    public void mousePressed(MouseEvent e) {
        action = (JButton)e.getSource();
        int x = e.getX();
        float rate=0;
        boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
             if (!doubleClick) {
             }
             pressed=true;
     }

     public void mouseReleased(MouseEvent e) {
       JButton action = (JButton)e.getSource();
       int x = e.getX();
       float rate=0;
       boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
       mouseDownTime = System.currentTimeMillis();
            if (pressed) {
            }
            pressed=false;
     }
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseDragged(MouseEvent e) {}
    public void mouseMoved(MouseEvent e) {
        JButton action = (JButton) e.getSource();
        int x = e.getX();
        boolean doubleClick = (System.currentTimeMillis() - mouseDownTime) <=
                              DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
        if (!false) {
            if (action == tobeginnButton) {
                IJ.showStatus("Beginn Slice");
            } else if (action == fwdButton) {
                IJ.showStatus("Next Slice");
            } else if (action == rotLeftButton) {
                IJ.showStatus("Rot Left 90");
            } else if (action == rotRightButton) {
                IJ.showStatus("Rot Right 90");
            }
            else if(action == selectButton){
                IJ.showStatus("Command: Select All");
            }
            else if(action == nonselectButton){
                IJ.showStatus("Select None");
            }
            else if (action == rotRoiButton) {
                IJ.showStatus("Rotate...");
            } else if (action == rotButton) {
                IJ.showStatus("Rotate Arbitrarily");
            } else if (action == scaleButton) {
                IJ.showStatus("Scale");
            } else if (action == flipHorizontalButton) {
                IJ.showStatus("Flip Horizontal");
            } else if (action == flipVerticalButton) {
                IJ.showStatus("Flip Verticaly");
            } else if (action == transButton) {
                IJ.showStatus("Translation");
            } else if (action == revButton) {
                IJ.showStatus("Previous Slice");
            } else if (action == toendButton) {
                IJ.showStatus("End Slice");
            }else if (action == draggedButton) {
                IJ.showStatus("Move...");
            } else if (action == closeButton) {
                IJ.showStatus("Decorated Frame");
            } else if (action == undecoratedButton) {
                IJ.showStatus("Undecorated Frame");
            }

        }
    }
    // Action listener method
    public void actionPerformed(ActionEvent e){
        try {
            if (action == tobeginnButton){
                toBeginn();
            }
              else if (action == revButton){
                  previous();
             }
              else if (action == fwdButton){
                  next();
              }
              else if (action == toendButton){
                  toEnd();
              }
              if (action == rotRoiButton){
                  IJ.runPlugIn("ij2x.plugin.RoiRotator", "");
                  //IJ.runPlugIn("ij.plugin.filter.Rotator", "");
              }
              if (action == rotLeftButton){
                 IJ.runPlugIn("ij.plugin.filter.Transformer", "left");
              }
                else if (action == rotRightButton){
                    IJ.runPlugIn("ij.plugin.filter.Transformer", "right");
               }
               else if(action == selectButton){
                   IJ.runPlugIn("ij.plugin.Selection", "all");
              }
              else if(action == nonselectButton){
                  IJ.runPlugIn("ij.plugin.Selection", "none");
              }
              else if (action == rotButton){
                   //IJ.runPlugIn("ij.plugin.Rotator", "");
                   IJ.runPlugIn("ij2x.plugin.RotateAll", "");
               }
               else if (action == scaleButton){
                   //IJ.runPlugIn("ij.plugin.filter.Scaler", "");
                   IJ.runPlugIn("ij2x.plugin.filter.ScaleAll", "");
               }
               else if (action == transButton){
                   IJ.runPlugIn("ij2x.plugin.Translator", "");
               }
               else if (action == flipHorizontalButton){
                   IJ.runPlugIn("ij.plugin.filter.Transformer", "fliph");
               }
               else if (action == flipVerticalButton){
                   IJ.runPlugIn("ij.plugin.filter.Transformer", "flipv");
               }
        }
         catch (Exception ex) {
        ex.printStackTrace();
    }

    }

}
