package ij2x.plugin.event;

import java.awt.Container;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

public class MoveMouseListener implements MouseListener, MouseMotionListener {
    private JComponent target;
    private Point start_drag;
    private Point start_loc;
    private boolean dragging;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;

    public MoveMouseListener(JComponent target) {
        this.target = target;
    }

    public static JFrame getFrame(Container target) {
        if(target instanceof JFrame) {
            return (JFrame)target;
        }
        return getFrame(target.getParent());
    }

    Point getScreenLocation(MouseEvent e) {
        Point cursor = e.getPoint();
        Point target_location = this.target.getLocationOnScreen();
        return new Point(
            (int)(target_location.getX()+cursor.getX()),
            (int)(target_location.getY()+cursor.getY()));
    }
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {
        this.start_drag = this.getScreenLocation(e);
        this.start_loc = this.getFrame(this.target).getLocation();
        dragging=true;
    }

    public void mouseReleased(MouseEvent e) {
        dragging=false;
    }

    public void mouseDragged(MouseEvent e) {
        boolean quickDragg = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
        if(dragging && SwingUtilities.isLeftMouseButton(e)) {
            Point current = this.getScreenLocation(e);
            Point offset = new Point(
                (int)current.getX()-(int)start_drag.getX(),
                (int)current.getY()-(int)start_drag.getY());
            JFrame frame = this.getFrame(target);
            Point new_location = new Point(
                (int)(this.start_loc.getX()+offset.getX()),
                (int)(this.start_loc.getY()+offset.getY()));
            frame.setLocation(new_location);
        }
    }
    public void mouseMoved(MouseEvent e) {}
}

